'
' ComboBox Color list include file - by Borje Hagsten, January 2001.
' Declares
'
#IF NOT %DEF(%WINAPI)
  #INCLUDE "WIN32API.INC"
#ENDIF
#IF NOT %DEF(%COMDLG32_INC)
  #INCLUDE "COMDLG32.INC"
#ENDIF

%CBCOL_SETAUTOCOLOR = %WM_USER + 100
%CBCOL_SETUSERCOLOR = %WM_USER + 101
%CBCOL_GETAUTOCOLOR = %WM_USER + 200
%CBCOL_GETUSERCOLOR = %WM_USER + 201
%CBCOL_GETSELCOLOR  = %WM_USER + 202

TYPE CBCOLORDATA
  oldProc   AS LONG
  autoColor AS LONG
  userColor AS LONG
  cols(15)  AS LONG
END TYPE
$CBCOLORDATAPTR = "CBCOLORDATAPTR"

DECLARE FUNCTION GetQBColor(BYVAL hWnd AS LONG, BYVAL c AS LONG, BYVAL dlg AS LONG) AS LONG
DECLARE FUNCTION CBProc(BYVAL hWnd AS LONG, BYVAL wMsg AS LONG, _
                        BYVAL wParam AS LONG, BYVAL lParam AS LONG) AS LONG

'********************************************************************

'********************************************************************
FUNCTION CreateCBColorList(BYVAL hWnd AS LONG, BYVAL CtrlId AS LONG, _
                           BYVAL vLeft AS LONG, BYVAL vTop AS LONG, _
                           BYVAL vWidth AS LONG, BYVAL vHeight AS LONG, _
                           BYVAL DDTstyle AS LONG, BYVAL autoCol AS LONG, BYVAL userCol AS LONG) AS LONG

  LOCAL I AS LONG, cl AS LONG, hCombo AS LONG, cbc AS CBCOLORDATA PTR
  REDIM arr(17) AS STRING

  'Create items for combo list
  arr(0)  = "Auto"          : arr(1)  = "Black"
  arr(2)  = "Blue"          : arr(3)  = "Green"
  arr(4)  = "Cyan"          : arr(5)  = "Red"
  arr(6)  = "Magenta"       : arr(7)  = "Brown"
  arr(8)  = "Light Gray"    : arr(9)  = "Gray"
  arr(10) = "Light Blue"    : arr(11) = "Light Green"
  arr(12) = "Light Cyan"    : arr(13) = "Light Red"
  arr(14) = "Light Magenta" : arr(15) = "Yellow"
  arr(16) = "Bright White"  : arr(17) = "User-selected.."

  IF DDTstyle THEN
     CONTROL ADD COMBOBOX, hWnd, CtrlId, arr(), vLeft, vTop, vWidth, vHeight, _
                 %WS_CHILD OR %WS_VISIBLE OR %CBS_OWNERDRAWFIXED OR %CBS_HASSTRINGS OR _
                 %CBS_DROPDOWNLIST OR %WS_TABSTOP OR %CBS_DISABLENOSCROLL OR %WS_VSCROLL', %WS_EX_CLIENTEDGE
     CONTROL HANDLE hWnd, CtrlId TO hCombo

  ELSE
     hCombo = CreateWindowEx(%WS_EX_CLIENTEDGE, "COMBOBOX", BYVAL 0, %WS_VISIBLE OR _
                             %WS_CHILD OR %WS_VISIBLE OR %CBS_OWNERDRAWFIXED OR %CBS_HASSTRINGS OR _
                             %CBS_DROPDOWNLIST OR %WS_TABSTOP OR %CBS_DISABLENOSCROLL OR %WS_VSCROLL, _
                             vLeft, vTop, vWidth, vHeight, _
                             hwnd, CtrlId, GetWindowLong(hWnd, %GWL_HINSTANCE), BYVAL 0)

     IF hCombo THEN              'add items to combo list
        FOR I = 0 TO UBOUND(arr)
           CALL SendMessage(hCombo, %CB_ADDSTRING, 0, BYVAL STRPTR(arr(I)) )
        NEXT
     END IF
  END IF

  IF hCombo = 0 THEN EXIT FUNCTION  'Return 0 to indicate failure

  cbc = HeapAlloc(GetProcessHeap(), %HEAP_ZERO_MEMORY, SIZEOF(@cbc))
  IF cbc THEN         'sub-class the combo and initialize some control specific data
     @cbc.oldProc   = SetWindowLong(hCombo, %GWL_WNDPROC, BYVAL CODEPTR(CBProc))
     @cbc.autoColor = autoCol 'usually %COLOR_WINDOW or %COLOR_WINDOWTEXT
     @cbc.userColor = userCol 'same here

     FOR I = 1 TO 16                        'create initial grayscale color map for
        cl = I * 16 - 1                     'COMDLG32's extra colors in ChooseColor dialog
        @cbc.cols(16 - I) = RGB(cl, cl, cl) 'note: array is static, but still local to each created control..
     NEXT

     SetProp hCombo, $CBCOLORDATAPTR, cbc   'store pointer to memory for UDT in control's property list
  ELSE
     EXIT FUNCTION                          'return 0 to indicate failure
  END IF

  FUNCTION = hCombo                         'return handle to indicate success
END FUNCTION

'
' Subclassed Combobox procedures
'
FUNCTION CBProc(BYVAL hWnd AS LONG, BYVAL wMsg AS LONG, _
                BYVAL wParam AS LONG, BYVAL lParam AS LONG) AS LONG

  LOCAL cbc AS CBCOLORDATA PTR : cbc = GetProp(hWnd, $CBCOLORDATAPTR) 'Get stored data

  SELECT CASE wMsg
     CASE %CBCOL_SETAUTOCOLOR : @cbc.autoColor = wParam   'allows programmer to change auto color
     CASE %CBCOL_SETUSERCOLOR : @cbc.userColor = wParam   'allows programmer to change user selected color
     CASE %CBCOL_GETAUTOCOLOR : FUNCTION = @cbc.autoColor 'allows programmer to get selected auto color
     CASE %CBCOL_GETUSERCOLOR : FUNCTION = @cbc.userColor 'allows programmer to get selected user color
     CASE %CBCOL_GETSELCOLOR  ' return selected color
        LOCAL lRes AS LONG
        lRes = SendMessage(hWnd, %CB_GETCURSEL, 0, 0)
        IF lRes > %CB_ERR THEN FUNCTION = GetQBColor(hWnd, lRes, 1)
        EXIT FUNCTION

     CASE %WM_DESTROY 'Un-subclass Combobox
        IF @cbc.oldProc THEN SetWindowLong hWnd, %GWL_WNDPROC, @cbc.oldProc
        IF cbc THEN CALL HeapFree(GetProcessHeap(), 0, BYVAL cbc)
        RemoveProp hWnd, $CBCOLORDATAPTR
        FUNCTION = 0 : EXIT FUNCTION

     CASE %WM_DRAWITEM
        LOCAL hBrush AS LONG, zTxt AS ASCIIZ * 80, lpdis AS DRAWITEMSTRUCT PTR, rct AS RECT

        lpdis = lParam
        IF @lpdis.itemID = &HFFFFFFFF& THEN EXIT FUNCTION

        SELECT CASE @lpdis.itemAction
           CASE %ODA_DRAWENTIRE, %ODA_SELECT
              'CLEAR BACKGROUND
              CALL FillRect(@lpdis.hDC, @lpdis.rcItem, GetSysColorBrush(%COLOR_WINDOW))

              'GET/DRAW TEXT
              CALL SendMessage(hWnd, %CB_GETLBTEXT, @lpdis.itemID, VARPTR(zTxt)) 'Get text
              CALL SetBkColor(@lpdis.hDC, GetSysColor(%COLOR_WINDOW))            'Set text Background
              CALL SetTextColor(@lpdis.hDC, GetSysColor(%COLOR_WINDOWTEXT))      'Set text color
              rct = @lpdis.rcItem
              rct.nLeft = 28
              DrawText @lpdis.hDC, zTxt, LEN(zTxt), rct, %DT_SINGLELINE OR %DT_LEFT OR %DT_VCENTER

              'SELECTED ITEM
              IF (@lpdis.itemState AND %ODS_SELECTED) THEN      'if selected
                 IF (@lpdis.itemState AND &H1000) = 0 THEN      'if not %ODS_COMBOBOXEDIT (= &H1000)
                    rct.nLeft   = 26 : rct.nRight = @lpdis.rcItem.nRight 'Set cordinates
                    rct.ntop    = @lpdis.rcItem.ntop
                    rct.nbottom = @lpdis.rcItem.nbottom
                    CALL InvertRect(@lpdis.hDC, rct)            'invert area around text only
                 END IF
                 CALL DrawFocusRect(@lpdis.hDC, @lpdis.rcItem)  'and draw a focus rectangle around all
              END IF

              'PAINT COLOR RECTANGLE (using RoundRect for nicer looks.. :-)
              IF (@lpdis.itemState AND &H1000) THEN             'if %ODS_COMBOBOXEDIT (= &H1000)
                 rct.nLeft   = 4 : rct.nRight = 24              'Set cordinates
              ELSE
                 rct.nLeft   = 3 : rct.nRight = 23              'a tiny bit to the left in list..
              END IF
              rct.ntop    = @lpdis.rcItem.ntop + 2
              rct.nbottom = @lpdis.rcItem.nbottom - 2
              hBrush = CreateSolidBrush(GetQBColor(hWnd, @lpdis.itemID, 0)) 'Create brush with proper color
              hBrush = SelectObject(@lpdis.hDC, hBrush)         'Select brush into device context
              CALL RoundRect(@lpdis.hDC, rct.nLeft, rct.ntop, rct.nRight, rct.nbottom, 3, 3) 'Draw
              DeleteObject SelectObject(@lpdis.hDC, hBrush)     'Select old brush back and delete new one

        END SELECT
        FUNCTION = %TRUE : EXIT FUNCTION

  END SELECT

  FUNCTION = CallWindowProc(@cbc.oldProc, hWnd, wMsg, wParam, lParam) 'pass on for processing in oldProc
END FUNCTION

'
' Basic QB color function.
'
FUNCTION GetQBColor(BYVAL hWnd AS LONG, BYVAL c AS LONG, BYVAL dlg AS LONG) AS LONG
  LOCAL cbc AS CBCOLORDATA PTR
  cbc = GetProp(hWnd, $CBCOLORDATAPTR)

  SELECT CASE c
     CASE  0 : FUNCTION = @cbc.autoColor   ' pre-set system color, like %COLOR_WINDOW or %COLOR_WINDOWTEXT
     CASE  1 : FUNCTION = RGB(0,0,0)       ' Black
     CASE  2 : FUNCTION = RGB(0,0,128)     ' Blue
     CASE  3 : FUNCTION = RGB(0,128,0)     ' Green
     CASE  4 : FUNCTION = RGB(0,128,128)   ' Cyan
     CASE  5 : FUNCTION = RGB(196,0,0)     ' Red
     CASE  6 : FUNCTION = RGB(128,0,128)   ' Magenta
     CASE  7 : FUNCTION = RGB(128,64,0)    ' Brown
     CASE  8 : FUNCTION = RGB(196,196,196) ' Light Gray
     CASE  9 : FUNCTION = RGB(128,128,128) ' Gray
     CASE 10 : FUNCTION = RGB(0,0,255)     ' Light Blue
     CASE 11 : FUNCTION = RGB(0,255,0)     ' Light Green
     CASE 12 : FUNCTION = RGB(0,255,255)   ' Light Cyan
     CASE 13 : FUNCTION = RGB(255,0,0)     ' Light Red
     CASE 14 : FUNCTION = RGB(255,0,255)   ' Light Magenta
     CASE 15 : FUNCTION = RGB(255,255,0)   ' Yellow
     CASE 16 : FUNCTION = RGB(255,255,255) ' Bright White
     CASE 17
        IF dlg THEN                                      'show COMDLG32's color selection dialog..
           LOCAL cc AS CHOOSECOLORAPI
           cc.lStructSize  = SIZEOF(cc)                  'fill structure..
           cc.lpCustColors = VARPTR(@cbc.cols(0))        'pointer to defined custom color array (a must, otherwise GPF..)
           cc.Flags        = %CC_RGBINIT OR %CC_FULLOPEN 'show entire dialog
           cc.hwndowner    = hWnd                        'best if control is owner, or..?
           cc.rgbResult    = @cbc.userColor              'give dialog chance to "auto-select" previously selected color
                                                         '(only works for base colors, but still better than nothing..)
           IF ChooseColor(cc) THEN @cbc.userColor = cc.rgbResult  'otherwise userColor is same as before
        END IF
        FUNCTION = @cbc.userColor                        'return user-selected color
  END SELECT
END FUNCTION
